/**************************************************************************
**
** This file is part of Qt Creator
**
** Copyright (c) 2010 Hugues Delorme
**
** Contact: Nokia Corporation (info@qt.nokia.com)
**
**
** GNU Lesser General Public License Usage
**
** This file may be used under the terms of the GNU Lesser General Public
** License version 2.1 as published by the Free Software Foundation and
** appearing in the file LICENSE.LGPL included in the packaging of this file.
** Please review the following information to ensure the GNU Lesser General
** Public License version 2.1 requirements will be met:
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights. These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** Other Usage
**
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Nokia.
**
** If you have questions regarding the use of this file, please contact
** Nokia at qt-info@nokia.com.
**
**************************************************************************/

#include "bazaarsettings.h"
#include "constants.h"

namespace Bazaar {
namespace Internal {

BazaarSettings::BazaarSettings()
{
    setBinary(QLatin1String(Constants::BAZAARDEFAULT));
}

BazaarSettings& BazaarSettings::operator=(const BazaarSettings& other)
{
    VCSBase::VCSBaseClientSettings::operator=(other);
    return *this;
}

bool BazaarSettings::sameUserId(const BazaarSettings& other) const
{
    return userName() == other.userName() && email() == other.email();
}

} // namespace Internal
} // namespace Bazaar
