/**************************************************************************
**
** This file is part of Qt Creator
**
** Copyright (c) 2011 Nokia Corporation and/or its subsidiary(-ies).
**
** Contact: Nokia Corporation (info@qt.nokia.com)
**
**
** GNU Lesser General Public License Usage
**
** This file may be used under the terms of the GNU Lesser General Public
** License version 2.1 as published by the Free Software Foundation and
** appearing in the file LICENSE.LGPL included in the packaging of this file.
** Please review the following information to ensure the GNU Lesser General
** Public License version 2.1 requirements will be met:
** http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights. These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** Other Usage
**
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Nokia.
**
** If you have questions regarding the use of this file, please contact
** Nokia at qt-info@nokia.com.
**
**************************************************************************/

#ifndef BOOKMARKS_GLOBAL_H
#define BOOKMARKS_GLOBAL_H

namespace Bookmarks {
namespace Constants {

const char * const BOOKMARKS_TOGGLE_ACTION      = "Bookmarks.Toggle";
const char * const BOOKMARKS_MOVEUP_ACTION      = "Bookmarks.MoveUp";
const char * const BOOKMARKS_MOVEDOWN_ACTION    = "Bookmarks.MoveDown";
const char * const BOOKMARKS_PREV_ACTION        = "Bookmarks.Previous";
const char * const BOOKMARKS_NEXT_ACTION        = "Bookmarks.Next";
const char * const BOOKMARKS_PREVDIR_ACTION     = "Bookmarks.PreviousDirectory";
const char * const BOOKMARKS_NEXTDIR_ACTION     = "Bookmarks.NextDirectory";
const char * const BOOKMARKS_PREVDOC_ACTION     = "Bookmarks.PreviousDocument";
const char * const BOOKMARKS_NEXTDOC_ACTION     = "Bookmarks.NextDocument";

const char * const BOOKMARKS_MENU               = "Bookmarks.Menu";
const char * const BOOKMARKS_CONTEXT            = "Bookmarks";

} // namespace Constants
} // namespace Bookmarks

#endif // BOOKMARKS_GLOBAL_H

